#include "fuzzy.h"
#include <stdlib.h>
#include <math.h>

fuzzy::fuzzy()
{
	fx=NULL;
	min=max=0;
	samples=0;
}
fuzzy::fuzzy(float min1,float max1,int samples1)
{
	min=min1,max=max1,samples=samples1;

	fx=(float *)malloc(samples*sizeof(float));
}
fuzzy::~fuzzy()
{
	free(fx);
}

void fuzzy::setconst(float c)
{
	int i;

	for(i=0;i<samples;i++) fx[i]=c;
}

void fuzzy::setfunction(float f(float))
{
	int i;
	float x;

	for(i=0;i<samples;i++)
	{
		x=min+i*(max-min)/(samples-1);
		fx[i]=f(x);
	}
}

void fuzzy::settriangle(float x1,float x2,float x3)
{
	int i;
	float x;

	for(i=0;i<samples;i++)
	{
		x=min+i*(max-min)/(samples-1);
		if((x<=x1)||(x>x3)) fx[i]=0;
		if((x>x1)&&(x<=x2)) fx[i]=(x-x1)/(x2-x1);
		if((x>x2)&&(x<=x3)) fx[i]=(x-x3)/(x2-x3);
	}

	////////////////////////////// ADDED BY DURIKE ////////////////////////////////
	// You can find more about DURIKE at: http://durike.yweb.sk or try Google ;) //
	///////////////////////////////////////////////////////////////////////////////
	//                                                                           //
	// Nasledovny kod bol pridany preto, aby bolo pomocou fuzzy mnoziny mozne    //
	// reprezentovat i uhly, ktore potrebuju mat osetrene to, ze dve hodnoty     //
	// vyjadruju ten isty uhol. Teda, ze 10 stupnov = 370 stupnov.               //
	//                                                                           //
	// Neosetruje sa tu ale zaporna cast!!! (Treba na to mysliet pri zadavani    //
	// hodnot)                                                                   //
	//                                                                           //
	///////////////////////////////////////////////////////////////////////////////

	if(x3 > max)	// ide o cyklicku fuzzy mnozinu?
	{
		float rozdiel = max-min;
		// posuniem hodnoty dolava o dlzku intervalu
		x1 -= rozdiel;
		x2 -= rozdiel;
		x3 -= rozdiel;
		
		x = min;
		i = 0;

		// kym nedokoncim cast funkcie, ktora presiahla za hodnotu "max", tak opakujem
		while((i < samples) && (x < x3))
		{
			x=min+i*(max-min)/(samples-1);
			if((x<=x1)||(x>x3)) fx[i]=0;
			if((x>x1)&&(x<=x2)) fx[i]=(x-x1)/(x2-x1);
			if((x>x2)&&(x<=x3)) fx[i]=(x-x3)/(x2-x3);
			i++;
		}
	}
}

void fuzzy::settrapezoid(float x1,float x2,float x3,float x4)
{
	int i;
	float x;

	for(i=0;i<samples;i++)
	{
		x=min+i*(max-min)/(samples-1);
		if((x<=x1)||(x>x4)) fx[i]=0;
		if((x>x1)&&(x<=x2)) fx[i]=(x-x1)/(x2-x1);
		if((x>x2)&&(x<=x3)) fx[i]=1;
		if((x>x3)&&(x<=x4)) fx[i]=(x-x4)/(x3-x4);
	}

	////////////////////////////// ADDED BY DURIKE ////////////////////////////////
	// You can find more about DURIKE at: http://durike.yweb.sk or try Google ;) //
	///////////////////////////////////////////////////////////////////////////////
	//                                                                           //
	// Nasledovny kod bol pridany preto, aby bolo pomocou fuzzy mnoziny mozne    //
	// reprezentovat i uhly, ktore potrebuju mat osetrene to, ze dve hodnoty     //
	// vyjadruju ten isty uhol. Teda, ze 10 stupnov = 370 stupnov.               //
	//                                                                           //
	// Neosetruje sa tu ale zaporna cast!!! (Treba na to mysliet pri zadavani    //
	// hodnot)                                                                   //
	//                                                                           //
	///////////////////////////////////////////////////////////////////////////////

	if(x4 > max)	// ide o cyklicku fuzzy mnozinu?
	{
		float rozdiel = max-min;
		// posuniem hodnoty dolava o dlzku intervalu
		x1 -= rozdiel;
		x2 -= rozdiel;
		x3 -= rozdiel;
		x4 -= rozdiel;
		
		x = min;
		i = 0;

		// kym nedokoncim cast funkcie, ktora presiahla za hodnotu "max", tak opakujem
		while((i < samples) && (x < x4))
		{
			x=min+i*(max-min)/(samples-1);
			if((x<=x1)||(x>x4)) fx[i]=0;
			if((x>x1)&&(x<=x2)) fx[i]=(x-x1)/(x2-x1);
			if((x>x2)&&(x<=x3)) fx[i]=1;
			if((x>x3)&&(x<=x4)) fx[i]=(x-x4)/(x3-x4);
			i++;
		}
	}
}

void fuzzy::setwell(float x1,float x2,float x3,float x4)
{
	int i;
	float x;

	for(i=0;i<samples;i++)
	{
		x=min+i*(max-min)/(samples-1);
		if((x<=x1)||(x>x4)) fx[i]=1;
		if((x>x1)&&(x<=x2)) fx[i]=(x2-x)/(x2-x1);
		if((x>x2)&&(x<=x3)) fx[i]=0;
		if((x>x3)&&(x<=x4)) fx[i]=(x3-x)/(x3-x4);
	}

	////////////////////////////// ADDED BY DURIKE ////////////////////////////////
	// You can find more about DURIKE at: http://durike.yweb.sk or try Google ;) //
	///////////////////////////////////////////////////////////////////////////////
	//                                                                           //
	// Nasledovny kod bol pridany preto, aby bolo pomocou fuzzy mnoziny mozne    //
	// reprezentovat i uhly, ktore potrebuju mat osetrene to, ze dve hodnoty     //
	// vyjadruju ten isty uhol. Teda, ze 10 stupnov = 370 stupnov.               //
	//                                                                           //
	// Neosetruje sa tu ale zaporna cast!!! (Treba na to mysliet pri zadavani    //
	// hodnot)                                                                   //
	//                                                                           //
	///////////////////////////////////////////////////////////////////////////////

	if(x4 > max)	// ide o cyklicku fuzzy mnozinu?
	{
		float rozdiel = max-min;
		// posuniem hodnoty dolava o dlzku intervalu
		x1 -= rozdiel;
		x2 -= rozdiel;
		x3 -= rozdiel;
		x4 -= rozdiel;
		
		x = min;
		i = 0;

		// kym nedokoncim cast funkcie, ktora presiahla za hodnotu "max", tak opakujem
		while((i < samples) && (x < x4))
		{
			x=min+i*(max-min)/(samples-1);
			if((x<=x1)||(x>x4)) fx[i]=1;
			if((x>x1)&&(x<=x2)) fx[i]=(x2-x)/(x2-x1);
			if((x>x2)&&(x<=x3)) fx[i]=0;
			if((x>x3)&&(x<=x4)) fx[i]=(x3-x)/(x3-x4);
			i++;
		}
	}
}

void fuzzy::setleft(float x1,float x2)
{
	int i;
	float x;

	for(i=0;i<samples;i++)
	{
		x=min+i*(max-min)/(samples-1);
		if(x<=x1) fx[i]=1;
		if((x>x1)&&(x<=x2)) fx[i]=(x-x2)/(x1-x2);
		if(x>x2) fx[i]=0;
	}

	////////////////////////////// ADDED BY DURIKE ////////////////////////////////
	// You can find more about DURIKE at: http://durike.yweb.sk or try Google ;) //
	///////////////////////////////////////////////////////////////////////////////
	//                                                                           //
	// Nasledovny kod bol pridany preto, aby bolo pomocou fuzzy mnoziny mozne    //
	// reprezentovat i uhly, ktore potrebuju mat osetrene to, ze dve hodnoty     //
	// vyjadruju ten isty uhol. Teda, ze 10 stupnov = 370 stupnov.               //
	//                                                                           //
	// Neosetruje sa tu ale zaporna cast!!! (Treba na to mysliet pri zadavani    //
	// hodnot)                                                                   //
	//                                                                           //
	///////////////////////////////////////////////////////////////////////////////

	if(x2 > max)	// ide o cyklicku fuzzy mnozinu?
	{
		float rozdiel = max-min;
		// posuniem hodnoty dolava o dlzku intervalu
		x1 -= rozdiel;
		x2 -= rozdiel;
		
		x = min;
		i = 0;

		// kym nedokoncim cast funkcie, ktora presiahla za hodnotu "max", tak opakujem
		while((i < samples) && (x < x2))
		{
			x=min+i*(max-min)/(samples-1);
			if(x<=x1) fx[i]=1;
			if((x>x1)&&(x<=x2)) fx[i]=(x-x2)/(x1-x2);
			if(x>x2) fx[i]=0;
			i++;
		}
	}
}

void fuzzy::setright(float x1,float x2)
{
	int i;
	float x;

	for(i=0;i<samples;i++)
	{
		x=min+i*(max-min)/(samples-1);
		if(x<=x1) fx[i]=0;
		if((x>x1)&&(x<=x2)) fx[i]=(x-x1)/(x2-x1);
		if(x>x2) fx[i]=1;
	}

	////////////////////////////// ADDED BY DURIKE ////////////////////////////////
	// You can find more about DURIKE at: http://durike.yweb.sk or try Google ;) //
	///////////////////////////////////////////////////////////////////////////////
	//                                                                           //
	// Nasledovny kod bol pridany preto, aby bolo pomocou fuzzy mnoziny mozne    //
	// reprezentovat i uhly, ktore potrebuju mat osetrene to, ze dve hodnoty     //
	// vyjadruju ten isty uhol. Teda, ze 10 stupnov = 370 stupnov.               //
	//                                                                           //
	// Neosetruje sa tu ale zaporna cast!!! (Treba na to mysliet pri zadavani    //
	// hodnot)                                                                   //
	//                                                                           //
	///////////////////////////////////////////////////////////////////////////////

	if(x2 > max)	// ide o cyklicku fuzzy mnozinu?
	{
		float rozdiel = max-min;
		// posuniem hodnoty dolava o dlzku intervalu
		x1 -= rozdiel;
		x2 -= rozdiel;
		
		x = min;
		i = 0;

		// kym nedokonimm cast funkcie, ktora presiahla za hodnotu "max", tak opakujem
		while((i < samples) && (x < x2))
		{
			x=min+i*(max-min)/(samples-1);
			if(x<=x1) fx[i]=0;
			if((x>x1)&&(x<=x2)) fx[i]=(x-x1)/(x2-x1);
			if(x>x2) fx[i]=1;
			i++;
		}
	}
}
void fuzzy::setvalues(float *v)
{
	int i;

	for(i=0;i<samples;i++) fx[i]=v[i];
}

void fuzzy::setandz(fuzzy &f1,fuzzy &f2)
{
	int i;

	for(i=0;i<samples;i++) fx[i]=(f1.indexvalue(i)<f2.indexvalue(i))?f1.indexvalue(i):f2.indexvalue(i);
}

void fuzzy::setorz(fuzzy &f1,fuzzy &f2)
{
	int i;

	for(i=0;i<samples;i++) fx[i]=(f1.indexvalue(i)>f2.indexvalue(i))?f1.indexvalue(i):f2.indexvalue(i);
}

void fuzzy::setandp(fuzzy &f1,fuzzy &f2)
{
	int i;

	for(i=0;i<samples;i++) fx[i]=f1.indexvalue(i)*f2.indexvalue(i);
}

void fuzzy::setorp(fuzzy &f1,fuzzy &f2)
{
	int i;

	for(i=0;i<samples;i++) fx[i]=1-(1-f1.indexvalue(i))*(1-f2.indexvalue(i));
}

void fuzzy::setandl(fuzzy &f1,fuzzy &f2)
{
	int i;

	for(i=0;i<samples;i++) fx[i]=(f1.indexvalue(i)+f2.indexvalue(i)>1)?f1.indexvalue(i)+f2.indexvalue(i)-1:0;
}

void fuzzy::setorl(fuzzy &f1,fuzzy &f2)
{
	int i;

	for(i=0;i<samples;i++) fx[i]=(f1.indexvalue(i)+f2.indexvalue(i)>1)?1:f1.indexvalue(i)+f2.indexvalue(i);
}

void fuzzy::setandz(fuzzy &f,float c)
{
	int i;

	for(i=0;i<samples;i++) fx[i]=(f.indexvalue(i)<c)?f.indexvalue(i):c;
}

void fuzzy::setorz(fuzzy &f,float c)
{
	int i;

	for(i=0;i<samples;i++) fx[i]=(f.indexvalue(i)>c)?f.indexvalue(i):c;
}

void fuzzy::setandp(fuzzy &f,float c)
{
	int i;

	for(i=0;i<samples;i++) fx[i]=f.indexvalue(i)*c;
}

void fuzzy::setorp(fuzzy &f,float c)
{
	int i;

	for(i=0;i<samples;i++) fx[i]=1-(1-f.indexvalue(i))*(1-c);
}

void fuzzy::setandl(fuzzy &f,float c)
{
	int i;

	for(i=0;i<samples;i++) fx[i]=(f.indexvalue(i)+c>1)?f.indexvalue(i)+c-1:0;
}

void fuzzy::setorl(fuzzy &f,float c)
{
	int i;

	for(i=0;i<samples;i++) fx[i]=(f.indexvalue(i)+c>1)?1:f.indexvalue(i)+c;
}
float fuzzy::value(float x)
{
	float index;

	if(x<=min) return(fx[0]);
	if(x>=max) return(fx[samples-1]);

	index=(x-min)*(samples-1)/(max-min);
	return(fx[(int)index]*(1-index+(int)index)+fx[(int)index+1]*(index-(int)index));
}
float fuzzy::indexvalue(int index)
{
	return(fx[index]);
}
float fuzzy::centroid()
{
	float nom=0,denom=0,x1,x2;
	int i;

	for(i=0;i<samples-1;i++)
	{
		x1=min+i*(max-min)/(samples-1);
		x2=min+(i+1)*(max-min)/(samples-1);

		nom+=fx[i]*(x2*x2/6+x1*x2/6-x1*x1/3)+fx[i+1]*(x2*x2/3-x1*x2/6-x1*x1/6);
		denom+=(x2-x1)*(fx[i+1]+fx[i])/2;
	}
	return((denom!=0)?(nom/denom):0);
}

float fuzzy::bisector()
{
	float all=0,half=0,x1,x2;
	int i;

	for(i=0;i<samples-1;i++)
	{
		x1=min+i*(max-min)/(samples-1);
		x2=min+(i+1)*(max-min)/(samples-1);


		all+=(x2-x1)*(fx[i+1]+fx[i])/2;
	}
	for(i=0;i<samples-1;i++)
	{
		x1=min+i*(max-min)/(samples-1);
		x2=min+(i+1)*(max-min)/(samples-1);

		if(half+(x2-x1)*(fx[i+1]+fx[i])/2<all/2) half+=(x2-x1)*(fx[i+1]+fx[i])/2;
		else
		{
			if(fx[i]!=fx[i+1]) return(x1+(-fx[i]+sqrt(fx[i]*fx[i]+(all-2*half)*(fx[i+1]-fx[i])/(x2-x1)))*(x2-x1)/(fx[i+1]-fx[i]));
			else return(x1+(all/2-half)/fx[i]);
		}
	}
	return(0);
}

float fuzzy::mom()
{
	int integ=0;
	float max=0,nom=0,denom=0,x1,x2;
	int i;

	for(i=0;i<samples;i++) if(fx[i]>max) max=fx[i];
	for(i=0;i<samples-1;i++) if((fx[i]==max)&&(fx[i+1]==max)) integ=1;

	if(integ)
	{
		for(i=0;i<samples-1;i++) if((fx[i]==max)&&(fx[i+1]==max))
		{
			x1=min+i*(max-min)/(samples-1);
			x2=min+(i+1)*(max-min)/(samples-1);
			nom+=(x2*x2-x1*x1)/2;
			denom+=x2-x1;
		}
	}
	else
	{
		for(i=0;i<samples;i++) if(fx[i]==max)
		{
			x1=min+i*(max-min)/(samples-1);
			nom+=x1;
			denom+=1;
		}
	}
	return((denom!=0)?(nom/denom):0);
}
float fuzzy::lom()
{
	float max;
	int i;

	for(i=0;i<samples;i++) if(fx[i]>max) max=fx[i];
	for(i=0;i<samples;i++) if(fx[i]==max) return(min+i*(max-min)/(samples-1));
	return(0);
}

float fuzzy::hom()
{
	float max;
	int i;

	for(i=0;i<samples;i++) if(fx[i]>max) max=fx[i];
	for(i=samples-1;i>=0;i--) if(fx[i]==max) return(min+i*(max-min)/(samples-1));
	return(0);
}

float andz(float c1,float c2)
{
	return((c1<c2)?c1:c2);
}
float orz(float c1,float c2)
{
	return((c1>c2)?c1:c2);
}
float andp(float c1,float c2)
{
	return(c1*c2);
}
float orp(float c1,float c2)
{
	return(c1+c2-c1*c2);
}
float andl(float c1,float c2)
{
	return((c1+c2-1>0)?(c1+c2-1):0);
}
float orl(float c1,float c2)
{
	return((c1+c2>1)?1:c1+c2);
} 
