#include <stdlib.h>
#include <math.h>

#define FZ_TRIANGLE 0
#define FZ_TRAPEZOID 1
#define FZ_CONST 2
#define FZ_LEFT 3
#define FZ_RIGHT 4
#define FZ_WELL 5

class fuzzy
{
	private:
		float *fx;
		float min,max;
		int samples;

	public:
		fuzzy();
		fuzzy(float min1,float max1,int samples1);
		~fuzzy();

		void setfunction(float f(float));
		void settriangle(float x1,float x2,float x3);
		void settrapezoid(float x1,float x2,float x3,float x4);
		void setconst(float c);
		void setwell(float x1,float x2,float x3,float x4);
		void setleft(float x1,float x2);
		void setright(float x1,float x2);
		void setvalues(float *v);

		void setandz(fuzzy &f1,fuzzy &f2);
		void setorz(fuzzy &f1,fuzzy &f2);
		void setandp(fuzzy &f1,fuzzy &f2);
		void setorp(fuzzy &f1,fuzzy &f2);
		void setandl(fuzzy &f1,fuzzy &f2);
		void setorl(fuzzy &f1,fuzzy &f2);

		void setandz(fuzzy &f,float c);
		void setorz(fuzzy &f,float c);
		void setandp(fuzzy &f,float c);
		void setorp(fuzzy &f,float c);
		void setandl(fuzzy &f,float c);
		void setorl(fuzzy &f,float c);

		float value(float x);
		float indexvalue(int index);

		float centroid();
		float bisector();
		float mom();
		float lom();
		float hom();
};

float andz(float c1,float c2);
float orz(float c1,float c2);
float andp(float c1,float c2);
float orp(float c1,float c2);
float andl(float c1,float c2);
float orl(float c1,float c2); 
